﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using EPiServer.Security;
using EPiServer.DataAbstraction;
using System.Web.Http;
using EPiServer;
using EPiServer.Core;
using EPiServer.ServiceLocation;
using EPiServer.Framework.DataAnnotations;
using EPiServer.Web.Mvc;
using EPiServer.Shell.Security;
using EPiServer.Web.Routing;
using AlloyCustomLogin.Models.Pages;
using AlloyCustomLogin.Models.ViewModels;

namespace AlloyCustomLogin.Controllers
{
    public class LoginPageController : PageControllerBase<LoginPage>
    {
        protected Injected<UIUserManager> UIUserManager;

        protected Injected<UIUserProvider> UIUserProvider;

        //protected Injected<UISignInManager> UISignInManager;
        //UISignInManager is declared in PageControllerBase class

        public ActionResult Index(LoginPage currentPage)
        {
            var model = new LoginPageViewModel(currentPage);
            return View(model);
        }

        [System.Web.Mvc.HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Index(LoginPage currentPage, [FromBody] LoginFormPostbackData loginData)
        {
            var model = new LoginPageViewModel(currentPage);
            if (ModelState.IsValid)
            {                
                bool isValid = UISignInManager.Service.SignIn(UIUserProvider.Service.Name, 
                    loginData.Username, loginData.Password);

                if (isValid)
                {
                    return Redirect(UrlResolver.Current.GetUrl(ContentReference.StartPage));
                }

                model.Message = "Wrong user name or password, try again!";
            }
            return View(model);
        }        
    }
}